<script setup>
import { provide, ref,watch,inject } from "vue";
import Counter from "../components/Counter.vue";
import Article from '../components/Article.vue'
import PopupVue from "../components/Popup.vue";
import InputVue from "../components/Input.vue";
import CardVue from "../components/Card.vue";
import ChildStyleVue from "../components/ChildStyle.vue";




const data=ref({
    volume:0,
    movie:"",
    movieInfo:{
        actor:"",
        titile:""
    }
})
const store=ref({
    name:"Muhammad Abdulloh Hamzan",
    profesi:"I am Software Engineer",
    title:"How to be good software Engineer",
    isPublish:true,
    likes:200


})

const dataPopUp=ref({
    showPopUp:false

})



watch( data.value,(newData,oldData)=>{

    if (newData.volume>16){
        alert("Bentar lagi tangki akan meledak !!!");
    }
    if (newData.movie){
        console.log("Callling Apiii bosquee")
    }
    if (newData.movieInfo){
        console.log(`calling api movie info titile ${newData.movieInfo.titile} and actor ${newData.movieInfo.actor}"`)
    }

});

const handeClosePopUp=(params)=>{
    console.log("masuk lemparan:",params)
    dataPopUp.value.showPopUp=false;
}


const input=ref({
    name:''
})
const handleChage=(e)=>{

    input.value.name=e.target.value

}

</script>

<template>
    <h2>Volume Tracker (0-20)</h2>
    <h2>Current volume- {{data.volume}}</h2>
    <button @click="data.volume+=2">Incresst</button>
    <button @click="data.volume-=2">Decresst</button>
    <input type="text" v-model="data.movie">
    <input type="text" v-model="data.movieInfo.actor" placeholder="input actor">
    <input type="text" v-model="data.movieInfo.titile" placeholder="input title">

    <Counter name='abdul' profesi="Software Engineer" />
    <Counter name='hamzan' profesi="Frontend Engineer" />
    <Counter :name= "store.name" :profesi="store.profesi" />
    <Article :title="store.title" :likes="store.likes" :isPublish="store.isPublish" />

    <button @click="dataPopUp.showPopUp=true">Open popUp</button>

    <PopupVue v-show="dataPopUp.showPopUp" @close="handeClosePopUp" />
    <h3>============ implementasi input=============</h3>
    <CardVue >hello mas abdul</CardVue>
    <CardVue>ini jg card 3 mas abdul</CardVue>
    <CardVue>
        <img src="https://picsum.photos/200" />
    </CardVue>
    <h4>App Component</h4>

    <ChildStyleVue />

    
</template>

<style lang="css"  scoped>

h4{
    color:"orange"
}


</style>



